package org.gcube.portlets.widgets.ckandatapublisherwidget.client.ui.TwinColumnSelection;

import com.google.gwt.cell.client.AbstractCell;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;

/**
 * Cell that renders left side panel objects
 * @author Costantino Perciante at ISTI-CNR (costantino.perciante@isti.cnr.it)
 */
public class ResourceCellLeft extends AbstractCell<ResourceElementBean>{

	@Override
	public void render(com.google.gwt.cell.client.Cell.Context context,
			ResourceElementBean value, SafeHtmlBuilder sb) {

		// Do not render an object if
		// - is null;
		// - has been moved to the other side;
		// - the parent folder is not null;
		if (value == null || value.isMovedToRight()) {
			return;
		}

		sb.appendHtmlConstant("<table style='width:100%'");
		sb.appendHtmlConstant("<tr><td><b>");
		sb.appendEscaped("Parent");
		sb.appendHtmlConstant("</b>");
		sb.appendEscaped(": " + (value.getParent() == null ? "-" : value.getParent().getName()));
		sb.appendHtmlConstant("</td></tr><td><b>");
		sb.appendEscaped("Name");
		sb.appendHtmlConstant("</b>");
		sb.appendEscaped(": " + value.getName());
		sb.appendHtmlConstant("</td></tr><td><b>");
		sb.appendEscaped("Type");
		sb.appendHtmlConstant("</b>");
		sb.appendEscaped(": " + (value.isFolder() ? "Folder" : "File"));
		sb.appendHtmlConstant("<td></tr></table>");
	}

}
